/* timer.h
 * encapsulates the windows timer
 * Copyright (C) 2002 Michel Leunen
 * http://www.leunen.com/
 * michel@leunen.com
 *
 * This software is freeware and is provided at no charge to the user.
 * This software is provided 'as-is', without any express or implied warranty.
 * To the maximum extent permitted by applicable law will the author NOT be held
 * liable for any damages whatsoever arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose, including
 * commercial applications, and to freely redistribute it, with the following
 * restrictions:
 *
 * 1. If you use this software in a product, an acknowledgment in the product
 *    documentation would be appreciated.
 *
 * 2. If you use this software in a commercial application, please send me an email
 *	  detailing the application.
 *
 * 3. This notice may not be removed or altered from any source distribution.
 *
 * 4. It may be distributed by any means, provided that the original files
 * 		as supplied by the author remain intact and no charge is made other than
 * 		for reasonable distribution costs. If you are a vendor, if you want to
 * 		include this software in a compilation or in a magazine cover disk
 * 		you HAVE TO CONTACT ME to obtain my authorization before distribution.
 */

#ifndef TIMER_H
#define TIMER_H
//------------------------------------------------------------
#include <windows.h>

//------------------------------------------------------------
namespace mlLib
{

class Timer
{
	private:
		static HWND hwnd_;
		unsigned int timerId_;
		bool CreateHiddenWindow();
		static LRESULT CALLBACK timerwndproc(HWND h,UINT msg,
				WPARAM wparam,LPARAM lparam);
		Timer(const Timer&);
		Timer& operator=(const Timer&);
	protected:
		virtual void OnTimer()=0;
	public:
		Timer();
		virtual ~Timer();
		bool Start();
		bool Stop();
		unsigned int Interval;	
};
//------------------------------------------------------------
} //end namespace mlLib
#endif
